#include "definitions.h"
#include "DisplayReplay.h"

#include "symbols/ffwd.xpm"
#include "symbols/ffwd1.xpm"
#include "symbols/ffwd2.xpm"
#include "symbols/ffwd3.xpm"
#include "symbols/frew.xpm"
#include "symbols/frew1.xpm"
#include "symbols/frew2.xpm"
#include "symbols/frew3.xpm"
#include "symbols/pause.xpm"
#include "symbols/play.xpm"
#include "symbols/sfwd.xpm"
#include "symbols/sfwd1.xpm"
#include "symbols/sfwd2.xpm"
#include "symbols/sfwd3.xpm"
#include "symbols/srew.xpm"
#include "symbols/srew1.xpm"
#include "symbols/srew2.xpm"
#include "symbols/srew3.xpm"

cBitmap cSkinElchiDisplayReplay::bmFfwd(ffwd_xpm);
cBitmap cSkinElchiDisplayReplay::bmFfwd1(ffwd1_xpm);
cBitmap cSkinElchiDisplayReplay::bmFfwd2(ffwd2_xpm);
cBitmap cSkinElchiDisplayReplay::bmFfwd3(ffwd3_xpm);
cBitmap cSkinElchiDisplayReplay::bmFrew(frew_xpm);
cBitmap cSkinElchiDisplayReplay::bmFrew1(frew1_xpm);
cBitmap cSkinElchiDisplayReplay::bmFrew2(frew2_xpm);
cBitmap cSkinElchiDisplayReplay::bmFrew3(frew3_xpm);
cBitmap cSkinElchiDisplayReplay::bmPause(pause_xpm);
cBitmap cSkinElchiDisplayReplay::bmPlay(play_xpm);
cBitmap cSkinElchiDisplayReplay::bmSfwd(sfwd_xpm);
cBitmap cSkinElchiDisplayReplay::bmSfwd1(sfwd1_xpm);
cBitmap cSkinElchiDisplayReplay::bmSfwd2(sfwd2_xpm);
cBitmap cSkinElchiDisplayReplay::bmSfwd3(sfwd3_xpm);
cBitmap cSkinElchiDisplayReplay::bmSrew(srew_xpm);
cBitmap cSkinElchiDisplayReplay::bmSrew1(srew1_xpm);
cBitmap cSkinElchiDisplayReplay::bmSrew2(srew2_xpm);
cBitmap cSkinElchiDisplayReplay::bmSrew3(srew3_xpm);

// --- cSkinElchiDisplayReplay ---------------------------------------------

cSkinElchiDisplayReplay::cSkinElchiDisplayReplay(bool ModeOnly)
{
  const cFont *font = cFont::GetFont(fontOsd);
  int lineHeight = font->Height();
  lastCurrentWidth = 0;
  message = false;
  cBitmap bm(play_xpm);
  x0 = 0;
  x1 = Setup.OSDWidth;
  x2 = Setup.OSDWidth - lineHeight - bmFrew.Width() - bmSrew.Width() - bmPlay.Width() - bmSfwd.Width() - bmFfwd.Width();
  x3 = x2 - 2 * lineHeight;
  y0 = 0;
  y1 = lineHeight;
  y2 = 2 * lineHeight;
  y3 = 3 * lineHeight;
  osd = cOsdProvider::NewOsd(Setup.OSDLeft, Setup.OSDTop + Setup.OSDHeight - y3);
  tArea Areas[] = { { x0, y0, x1 - 1, y3 - 1, 4 } };
  osd->SetAreas(Areas, sizeof(Areas) / sizeof(tArea));
  if (ModeOnly) {
      osd->DrawRectangle(x0, y0, x1 - 1, y2 - 1, clrTransparent);
      osd->DrawRectangle(x2, y2, x2 + lineHeight / 2 - 1, y3 - 1, clrTransparent);
      osd->DrawEllipse(x2, y2, x2 + lineHeight / 2 - 1, y3 - 1, Theme.Color(clrBackground), 7);
      osd->DrawRectangle(x2 + lineHeight / 2, y2, x1 - lineHeight / 2 - 1, y3 - 1, Theme.Color(clrBackground));
      osd->DrawRectangle(x1 - lineHeight / 2, y2, x1 - 1, y3 - 1, clrTransparent);
      osd->DrawEllipse(x1 - lineHeight / 2, y2, x1 - 1, y3 - 1, Theme.Color(clrBackground), 5);
      }
  else {
      osd->DrawRectangle(x0, y0, x2 - 1, y1 - 1, clrTransparent);
      osd->DrawSlope(x3, y0, x2 - 1, y1 - 1, Theme.Color(clrBackground), 0);
      osd->DrawRectangle(x2, y0, x1 - lineHeight / 2 - 1, y1 - 1, Theme.Color(clrBackground));

      osd->DrawRectangle(x1 - lineHeight / 2, y0, x1 - 1, y1 - lineHeight / 2 - 1, clrTransparent);
      osd->DrawEllipse(x1 - lineHeight / 2, y0, x1 - 1, y1 - lineHeight / 2 - 1, Theme.Color(clrBackground), 1);

      osd->DrawRectangle(x0 + lineHeight / 2, y1, x0 + lineHeight - 1, y2 - 1, clrTransparent);
      osd->DrawEllipse(x0 + lineHeight / 2, y1, x0 + lineHeight - 1, y2 - 1, Theme.Color(clrBackground), 7);
      osd->DrawRectangle(x0 + lineHeight, y1, x1 - lineHeight / 2 - 1, y2 - 1, Theme.Color(clrBackground));

      osd->DrawRectangle(x0, y2, x2 - 1, y3 - 1, clrTransparent);
      osd->DrawSlope(x3, y2, x2 - 1, y3 - 1, Theme.Color(clrBackground), 3);

      osd->DrawRectangle(x1 - lineHeight / 2, y1 - lineHeight / 2, x1 - 1, y2 + lineHeight / 2, Theme.Color(clrBackground));

      osd->DrawRectangle(x2, y0, x1 - lineHeight / 2 - 1, y3 - 1, Theme.Color(clrBackground));

      osd->DrawRectangle(x1 - lineHeight / 2, y3 - lineHeight / 2, x1 - 1, y3 - 1, clrTransparent);
      osd->DrawEllipse(x1 - lineHeight / 2, y3 - lineHeight / 2, x1 - 1, y3 - 1, Theme.Color(clrBackground), 4);
      }
}

cSkinElchiDisplayReplay::~cSkinElchiDisplayReplay()
{
  delete osd;
}

void cSkinElchiDisplayReplay::SetTitle(const char *Title)
{
  char *title;
  asprintf(&title," %s ", Title);
  const cFont *font = cFont::GetFont(fontOsd);
  const cFont *smallfont = cFont::GetFont(fontSml);
  int w = smallfont->Width(title);
  int x = x1 - (x1 - x3);
  int h = font->Height() - smallfont->Height();
  w = (w > x) ? x : w;
  osd->DrawText(x0, y0, title, Theme.Color(clrReplayTitleFg), Theme.Color(clrReplayTitleBg), smallfont, w);
  osd->DrawRectangle(w, y0 + 3, w + 3 - 1, y1 - h + 3, Theme.Color(clrBackground));
  osd->DrawRectangle(x0 + 3, y1 - h, w - 1, y1 - h + 3, Theme.Color(clrBackground));
  free(title);
}

void cSkinElchiDisplayReplay::SetMode(bool Play, bool Forward, int Speed)
{
  if (Setup.ShowReplayMode) {
     int x = x2 + y1 / 2;
     if (Speed < -1)
        Speed = -1;
     if (Speed > 4)
        Speed = 4;
     if ((Speed > -1) && Play && !Forward) {
        switch (Speed) {
            case 0:
	    case 1: osd->DrawBitmap(x, y2 + (y3 - y2 - bmFrew.Height()) / 2, bmFrew, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
	    case 2: osd->DrawBitmap(x, y2 + (y3 - y2 - bmFrew.Height()) / 2, bmFrew1, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
	    case 3: osd->DrawBitmap(x, y2 + (y3 - y2 - bmFrew.Height()) / 2, bmFrew2, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
	    case 4: osd->DrawBitmap(x, y2 + (y3 - y2 - bmFrew.Height()) / 2, bmFrew3, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
	}
     }
     else
        osd->DrawBitmap(x, y2 + (y3 - y2 - bmFrew.Height()) / 2, bmFrew, Theme.Color(clrReplaySymbolOff), Theme.Color(clrBackground));
     x += bmFrew.Width();

     if ((Speed > -1) && !Play && !Forward) {
        switch (Speed) {
            case 0:
            case 1: osd->DrawBitmap(x, y2 + (y3 - y2 - bmSrew.Height()) / 2, bmSrew, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
            case 2: osd->DrawBitmap(x, y2 + (y3 - y2 - bmSrew.Height()) / 2, bmSrew1, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
            case 3: osd->DrawBitmap(x, y2 + (y3 - y2 - bmSrew.Height()) / 2, bmSrew2, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
            case 4: osd->DrawBitmap(x, y2 + (y3 - y2 - bmSrew.Height()) / 2, bmSrew3, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
	}
     }
     else
        osd->DrawBitmap(x, y2 + (y3 - y2 - bmSrew.Height()) / 2, bmSrew, Theme.Color(clrReplaySymbolOff), Theme.Color(clrBackground));
     x += bmSrew.Width();

     if (Speed == -1)
	osd->DrawBitmap(x, y2 + (y3 - y2 - bmPlay.Height()) / 2, Play ? bmPlay : bmPause, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground));
     else
        osd->DrawBitmap(x, y2 + (y3 - y2 - bmPlay.Height()) / 2, bmPlay, Theme.Color(clrReplaySymbolOff), Theme.Color(clrBackground));
     x += bmPlay.Width();
     
     if ((Speed > -1) && !Play && Forward) {
        switch (Speed) {
            case 0:
            case 1: osd->DrawBitmap(x, y2 + (y3 - y2 - bmSfwd.Height()) / 2, bmSfwd, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
            case 2: osd->DrawBitmap(x, y2 + (y3 - y2 - bmSfwd.Height()) / 2, bmSfwd2, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
            case 3: osd->DrawBitmap(x, y2 + (y3 - y2 - bmSfwd.Height()) / 2, bmSfwd3, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
            case 4: osd->DrawBitmap(x, y2 + (y3 - y2 - bmSfwd.Height()) / 2, bmSfwd3, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
	}
     }
     else
	osd->DrawBitmap(x, y2 + (y3 - y2 - bmSfwd.Height()) / 2, bmSfwd, Theme.Color(clrReplaySymbolOff), Theme.Color(clrBackground));
     x += bmSfwd.Width();

     if ((Speed > -1) && Play && Forward) {
        switch (Speed) {
            case 0:
	    case 1: osd->DrawBitmap(x, y2 + (y3 - y2 - bmFfwd.Height()) / 2, bmFfwd, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
            case 2: osd->DrawBitmap(x, y2 + (y3 - y2 - bmFfwd.Height()) / 2, bmFfwd1, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
            case 3: osd->DrawBitmap(x, y2 + (y3 - y2 - bmFfwd.Height()) / 2, bmFfwd2, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
            case 4: osd->DrawBitmap(x, y2 + (y3 - y2 - bmFfwd.Height()) / 2, bmFfwd3, Theme.Color(clrReplaySymbolOn), Theme.Color(clrBackground)); break;
	}
     }
     else
        osd->DrawBitmap(x, y2 + (y3 - y2 - bmFfwd.Height()) / 2, bmFfwd, Theme.Color(clrReplaySymbolOff), Theme.Color(clrBackground));
     }
}

void cSkinElchiDisplayReplay::SetProgress(int Current, int Total)
{
  cProgressBar pb(x1 - x0 - y1 - y1 / 2, y2 - y1 - 8, Current, Total, marks, Theme.Color(clrReplayProgressSeen), Theme.Color(clrReplayProgressRest), Theme.Color(clrReplayProgressSelected), Theme.Color(clrReplayProgressMark), Theme.Color(clrReplayProgressCurrent));
  osd->DrawBitmap(x0 + y1, y1 + 4, pb);
}

void cSkinElchiDisplayReplay::SetCurrent(const char *Current)
{
  const cFont *font = cFont::GetFont(fontSml);
  int v = font->Width("00:00:00");
  char *current;
  asprintf(&current,"%s %s ", Current, "/");
  int w = font->Width(current);
  osd->DrawText(x1 - w - v - y1 / 2, y0, current, Theme.Color(clrReplayCurrent), Theme.Color(clrBackground), font, lastCurrentWidth > w ? lastCurrentWidth : 0);
  free(current);
  lastCurrentWidth = w;
}

void cSkinElchiDisplayReplay::SetTotal(const char *Total)
{
  const cFont *font = cFont::GetFont(fontSml);
  osd->DrawText(x1 - font->Width(Total) - y1 / 2, y0, Total, Theme.Color(clrReplayTotal), Theme.Color(clrBackground), font);
}

void cSkinElchiDisplayReplay::SetJump(const char *Jump)
{
  osd->DrawText(x0 + (x2 - x0) / 4, y2, Jump, Theme.Color(clrReplayModeJump), Theme.Color(clrBackground), cFont::GetFont(fontOsd), (x2 - x0) / 2, 0, taCenter);
}

void cSkinElchiDisplayReplay::SetMessage(eMessageType Type, const char *Text)
{
  const cFont *font = cFont::GetFont(fontOsd);
  if (Text) {
     int lineHeight = font->Height();
     osd->SaveRegion(x3, y2, x1 - 1, y3 - 1);
     osd->DrawEllipse(x0, y2, lineHeight / 2 - 1, y3 - 1, Theme.Color(clrMessageStatusBg + 2 * Type), 7);
     osd->DrawText(x0 + lineHeight / 2, y2, Text, Theme.Color(clrMessageStatusFg + 2 * Type), Theme.Color(clrMessageStatusBg + 2 * Type), font, x1 - x0 - lineHeight, y3 - y2, taCenter);
     osd->DrawEllipse(x1 - lineHeight / 2, y2, x1 - 1, y3 - 1, Theme.Color(clrMessageStatusBg + 2 * Type), 5);
     message = true;
     }
  else {
     osd->RestoreRegion();
     message = false;
     }
}

void cSkinElchiDisplayReplay::Flush(void)
{
  osd->Flush();
}
