#include "setup.h"

cSkinElchiSetup SkinElchiSetup;

static const char allowed[] = { " abcdefghijklmnopqrstuvwxyz0123456789-_/" };
static const char hex[] = { "0123456789abcdef" };
bool colorexit;

// --- cSkinElchiSetup ----------------------------------------------------------

cSkinElchiSetup::cSkinElchiSetup(void)
{
	color = false;
	logo = 0;
	hidemenu = true;
	strncpy(menuentry,"Elchi_VDR_Skin-Plugin",sizeof(menuentry));
}


bool cSkinElchiSetup::SetupParse(const char *Name, const char *Value)
{
	if      (strcmp(Name, "logo")        	 == 0) logo            = atoi(Value);
	else if	(strcmp(Name, "hidemenu")   	 == 0) hidemenu	       = atoi(Value);
	else if (!strcasecmp(Name, "menuentry"))   snprintf(menuentry, sizeof(menuentry), Value);
	else return false;
	return true;
}


// --- cSkinElchiSetupPage ------------------------------------------------------

cSkinElchiSetupPage::cSkinElchiSetupPage(void)
{
	mySkinElchiSetup = SkinElchiSetup;
	
	Add(new cMenuEditBoolItem(tr("Logo"), &mySkinElchiSetup.logo, tr("no"), tr("yes") ) );
	Add(new cMenuEditBoolItem(tr("Color"), &mySkinElchiSetup.color, tr("hide"), tr("show") ) );
	if (mySkinElchiSetup.color) {
	    for (int i = 0; i < Theme.MaxThemeColors; i++)
	    {
    		char *d;
    		asprintf(&d, "  %d", i);
		char *s;
    		asprintf(&s, "%08x", (int)Theme.Color(i));
		strncpy(mySkinElchiSetup.tempcolor, s,sizeof(mySkinElchiSetup.tempcolor));
		free(s);
		Add(new cMenuEditStrItem(d, mySkinElchiSetup.tempcolor, sizeof(mySkinElchiSetup.tempcolor), hex));
    		free(d);
	    }
	}
	Add(new cMenuEditBoolItem(tr("Hide Mainmenu Entry"), &mySkinElchiSetup.hidemenu, tr("no"), tr("yes") ) );
	if (!mySkinElchiSetup.hidemenu)
	    Add(new cMenuEditStrItem ( tr("Mainmenu Entry"), mySkinElchiSetup.menuentry, sizeof(mySkinElchiSetup.menuentry), allowed));
}


eOSState cSkinElchiSetupPage::ProcessKey(eKeys Key)
{
	bool oldhidemenu = mySkinElchiSetup.hidemenu;
	bool oldcolor = mySkinElchiSetup.color;
	eOSState state = cMenuSetupPage::ProcessKey(Key);

	if (oldcolor != mySkinElchiSetup.color)
	{
	    cOsdItem *item = Get(Current());
	    if (mySkinElchiSetup.color) {
		int oldcurrent = Current();
		Clear();
		Add(new cMenuEditBoolItem(tr("Logo"), &mySkinElchiSetup.logo, tr("no"), tr("yes") ) );
		Add(new cMenuEditBoolItem(tr("Color"), &mySkinElchiSetup.color, tr("hide"), tr("show") ) );
		for (int i = 0; i < Theme.MaxThemeColors; i++)
		{
    		    char *d;
    		    asprintf(&d, "  %d", i);
		    char *s;
    		    asprintf(&s, "%08x", (int)Theme.Color(i));
		    strncpy(mySkinElchiSetup.tempcolor, s,sizeof(mySkinElchiSetup.tempcolor));
		    free(s);
		    Add(new cMenuEditStrItem(d, mySkinElchiSetup.tempcolor, sizeof(mySkinElchiSetup.tempcolor), hex));
    		    free(d);
		}
		Add(new cMenuEditBoolItem(tr("Hide Mainmenu Entry"), &mySkinElchiSetup.hidemenu, tr("no"), tr("yes") ) );
		if (!mySkinElchiSetup.hidemenu)
		{
		    Add(new cMenuEditStrItem ( tr("Mainmenu Entry"), mySkinElchiSetup.menuentry, sizeof(mySkinElchiSetup.menuentry), allowed));
		}
		SetCurrent(Get(oldcurrent));
	    }
	    else
	    {
		for (int i = Theme.MaxThemeColors ; i>0 ;i--)
		{
	    	    item = Get(Current()+i);
	    	    cList<cOsdItem>::Del(item, false);
		}
	    }
	    Display();
	}

	if (oldhidemenu != mySkinElchiSetup.hidemenu)
	{
	    cOsdItem *item = Get(Current());
	    if (!mySkinElchiSetup.hidemenu)
	    {
		Add(new cMenuEditStrItem ( tr("Mainmenu Entry"), mySkinElchiSetup.menuentry, sizeof(mySkinElchiSetup.menuentry), allowed));
	    }
	    else
	    {
		for (int i=1;i>0;i--)
		{
	    	    item = Get(Current()+i);
	    	    cList<cOsdItem>::Del(item, false);
		}
	    }
	    Display();
	}
	return state;
}

cSkinElchiSetupPage::~cSkinElchiSetupPage()
{
}


void cSkinElchiSetupPage::Store(void)
{
	SkinElchiSetup = mySkinElchiSetup;
	SetupStore("logo", SkinElchiSetup.logo);
	SetupStore("hidemenu", SkinElchiSetup.hidemenu);
	SetupStore("menuentry", SkinElchiSetup.menuentry);
}

