/*
 * skinclassic.c: The 'classic' VDR skin
 *
 * See the main source file 'vdr.c' for copyright information and
 * how to reach the author.
 *
 * $Id: skinclassic.c 1.11 2005/01/09 11:56:29 kls Exp $
 */

#include "setup.h"
#include "definitions.h"
#include "DisplayChannel.h"
#include "DisplayMenu.h"
#include "DisplayReplay.h"
#include "DisplayVolume.h"
#include "DisplayTracks.h"
#include "DisplayMessage.h"
#include "skinelchi.h"
#include "i18n.h"
#include <vdr/font.h>
#include <vdr/osd.h>
#include <vdr/menu.h>
#include <vdr/themes.h>
#include <vdr/plugin.h>

static const char *VERSION        = "0.0.1";
static const char *DESCRIPTION    = "Elchi VDR Skin-Plugin";

// --- cSkinElchi ----------------------------------------------------------

cSkinElchi::cSkinElchi(void)
:cSkin("Elchi_Plugin", &::Theme)//XXX naming problem???
{
}

const char *cSkinElchi::Description(void)
{
  return tr("Elchi (Plugin)");
}

cSkinDisplayChannel *cSkinElchi::DisplayChannel(bool WithInfo)
{
  return new cSkinElchiDisplayChannel(WithInfo);
}

cSkinDisplayMenu *cSkinElchi::DisplayMenu(void)
{
  return new cSkinElchiDisplayMenu;
}

cSkinDisplayReplay *cSkinElchi::DisplayReplay(bool ModeOnly)
{
  return new cSkinElchiDisplayReplay(ModeOnly);
}

cSkinDisplayVolume *cSkinElchi::DisplayVolume(void)
{
  return new cSkinElchiDisplayVolume;
}


cSkinDisplayTracks *cSkinElchi::DisplayTracks(const char *Title, int NumTracks, const char * const *Tracks)
{
  return new cSkinElchiDisplayTracks(Title, NumTracks, Tracks);
}

cSkinDisplayMessage *cSkinElchi::DisplayMessage(void)
{
  return new cSkinElchiDisplayMessage;
}

// --- cPluginSkinElchi -----------------------------------------------------

class cPluginSkinElchi : public cPlugin {
private:
public:
  cPluginSkinElchi(void);
  virtual ~cPluginSkinElchi();
  virtual const char *Version(void) { return VERSION; }
  virtual const char *Description(void) { return DESCRIPTION; }
  virtual const char *CommandLineHelp(void);
  virtual bool ProcessArgs(int argc, char *argv[]);
  virtual bool Initialize(void);
  virtual bool Start(void);
  virtual void Housekeeping(void);
  virtual const char *MainMenuEntry(void) { return (SkinElchiSetup.hidemenu ? NULL :SkinElchiSetup.menuentry); }
  virtual cOsdObject *MainMenuAction(void);
  virtual cMenuSetupPage *SetupMenu(void);
  virtual bool SetupParse(const char *Name, const char *Value);
};

cPluginSkinElchi::cPluginSkinElchi(void)
{
}

cPluginSkinElchi::~cPluginSkinElchi()
{
}

const char *cPluginSkinElchi::CommandLineHelp(void)
{
  return NULL;
}

bool cPluginSkinElchi::ProcessArgs(int argc, char *argv[])
{
  return true;
}

bool cPluginSkinElchi::Initialize(void)
{
  return true;
}

bool cPluginSkinElchi::Start(void)
{
  new cSkinElchi;
  return true;
}

void cPluginSkinElchi::Housekeeping(void)
{
}

cOsdObject *cPluginSkinElchi::MainMenuAction(void)
{
  return new cSkinElchiSetupPage;
}

cMenuSetupPage *cPluginSkinElchi::SetupMenu(void)
{
  return new cSkinElchiSetupPage;
}

bool cPluginSkinElchi::SetupParse(const char *Name, const char *Value)
{
  return SkinElchiSetup.SetupParse(Name, Value);
}

VDRPLUGINCREATOR(cPluginSkinElchi); // Don't touch this!
